class CommunitiesController < ApplicationController
  def index
    list
    render :action => 'list'
  end

  def list
    @community_pages, @communities = paginate :community, :per_page => 10
  end

  def show
    @community = Community.find(params[:id])
  end

  def new
    @community = Community.new
  end

  def create
    @community = Community.new(params[:community])
    if @community.save
      flash[:notice] = 'Community was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @community = Community.find(params[:id])
  end

  def update
    @community = Community.find(params[:id])
    if @community.update_attributes(params[:community])
      flash[:notice] = 'Community was successfully updated.'
      redirect_to :action => 'show', :id => @community
    else
      render :action => 'edit'
    end
  end

  def destroy
    Community.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
end
