require File.dirname(__FILE__) + '/../test_helper'
require 'account_controller'

# Re-raise errors caught by the controller.
class AccountController; def rescue_action(e) raise e end; end

class AccountControllerTest < Test::Unit::TestCase
  fixtures :users

  def setup
    @controller = AccountController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new
  end

  def test_auth_bob
    post "authenticate", "me"=>{"name"=>"bob", "password"=>"s3cret"}
    assert_redirected_to :action=>"welcome"
    assert_equal @bob, session["me"]
  end

  def test_invalid_login
    post "authenticate", "me"=>{"name"=>"bob", "password"=>"not_correct"}
    assert_redirected_to :action=>"login"
    assert_nil session["me"]
  end

  def test_login_logout
    post "authenticate", "me"=>{"name"=>"bob", "password"=>"s3cret"}
    assert_redirected_to :action=>"welcome"
    assert session["me"]

    get "logout"
    assert_template "logout"
    assert_nil session["me"]
  end

end
